local handler = require("event_handler")
handler.add_lib(require("sandbox"))
handler.add_lib(require("silo-script"))

script.on_nth_tick(1, function(event) 
    if global.rand == nil then
        global.rand = game.create_random_generator()
    end

    surf = game.surfaces["nauvis"]

    pipe_acid_1 = surf.find_entity("pipe", {-4.5, -1.5})
    pipe_acid_2 = surf.find_entity("pipe", {-0.5, -1.5})
    pipe_crude_1 = surf.find_entity("pipe", {-4.5, 1.5})
    cutter = surf.find_entity("pipe-to-ground", {-2.5, -1.5})

    if pipe_acid_1.fluidbox.get_locked_fluid(1) ~= "sulfuric-acid" or pipe_crude_1.fluidbox.get_locked_fluid(1) ~= "crude-oil" then
        game.print("fluid mixing detected, tick=".. tostring(event.tick))
        script.on_nth_tick(nil)
        return
    end

    if pipe_acid_2.fluidbox.get_locked_fluid(1) == "sulfuric-acid" then
        if cutter ~= nil then
            game.print("locked fluid system without filter detected, tick=".. tostring(event.tick))
            script.on_nth_tick(nil)
            return
        end
        -- insert cutter because underground section is connected
        if surf.can_place_entity{name="pipe-to-ground", position={-2.5,-1.5}, direction=defines.direction.east, force="player"} then
            surf.create_entity{name="pipe-to-ground", position={-2.5,-1.5}, direction=defines.direction.east, force="player"}
        end
    elseif pipe_acid_2.fluidbox.get_locked_fluid(1) == "crude-oil" then
        -- remove cutter because underground will be disconnected
        if cutter ~= nil then
            cutter.destroy()
        end
    end

    x = global.rand(0,6) + 0.5
    y = global.rand(0,6) + 0.5
    e = surf.find_entities({{x-0.1, y-0.1},{x+0.1, y+0.1}})
    p = {x, y}
    action = global.rand(1,10)

    -- if event.tick == 353308 then
    --     game.print("x="..tostring(x)..",y="..tostring(y)..",action="..tostring(action))
    --     script.on_nth_tick(nil)
    --     return
    -- end 

    if action == 1 and #e >= 1 then
        -- remove entity
        for i=1,#e do
            e[i].destroy()
        end
    elseif action <= 5 then
        -- create pipe
        if surf.can_place_entity{name="pipe", position=p, force="player"} then
            surf.create_entity{name="pipe", position=p, force="player"}
        end
    elseif action == 6 then
        -- create pipe-to-ground
        dir = global.rand(0,3)
        if dir == 0 then dir = defines.direction.north
        elseif dir == 1 then dir = defines.direction.south
        elseif dir == 2 then dir = defines.direction.east
        elseif dir == 3 then dir = defines.direction.west
        end

        if surf.can_place_entity{name="pipe-to-ground", position=p, direction=dir, force="player"} then
            surf.create_entity{name="pipe-to-ground", position=p, direction=dir, force="player"}
        end
    elseif action == 7 then
        -- create pipe ghost
        if surf.can_place_entity{name="pipe", position=p, direction=dir, force="player"} then
            surf.create_entity{name="entity-ghost", inner_name="pipe", position=p, direction=dir, force="player"}
        end
    elseif action == 8 then
        -- -- create pipe-to-ground ghost
        dir = global.rand(0,3)
        if dir == 0 then dir = defines.direction.north
        elseif dir == 1 then dir = defines.direction.south
        elseif dir == 2 then dir = defines.direction.east
        elseif dir == 3 then dir = defines.direction.west
        end

        if surf.can_place_entity{name="pipe-to-ground", position=p, direction=dir, force="player"} then
            surf.create_entity{name="entity-ghost", inner_name="pipe-to-ground", position=p, direction=dir, force="player"}
        end
    elseif action == 9 and #e >= 1 then
        e[1].rotate({reverse=false})
    elseif action == 10 and #e >= 1 then
        e[1].rotate({reverse=true})
    end
end)
